#ifndef ISEGAPI_H
#define ISEGAPI_H

#ifdef __cplusplus
	extern "C" {
#endif

#include "isegcommon.h"

#define ISEG_OK           0
#define ISEG_ERROR        1

#define CRATE_ADDESS_OFFSET 1000

typedef struct IsegItemValue {
	char object[FULLY_QUALIFIED_OBJECT_SIZE];	//line.module.channel.item  0.0.1.VoltageSet
	char value[VALUE_SIZE];
	char quality[QUALITY_SIZE];
	char timeStampLastRefreshed[TIME_SIZE];
	char timeStampLastChanged[TIME_SIZE];
} IsegItemValue;
#define EmptyIsegItemValue { "" ,"" , "", "", ""}

#define CAN_STATE_ERROR_ACTIVE_STRING    "00"	/* RX/TX error count < 96 */
#define CAN_STATE_ERROR_WARNING_STRING   "01"	/* RX/TX error count < 128 */
#define CAN_STATE_ERROR_PASSIVE_STRING   "02"	/* RX/TX error count < 256 */
#define CAN_STATE_BUS_OFF_STRING         "03"	/* RX/TX error count >= 256 */
#define CAN_STATE_STOPPED_STRING         "04"	/* Device is stopped */
#define CAN_STATE_SLEEPING_STRING        "05"	/* Device is sleeping */
#define CAN_STATE_SERIOUSLY_ERROR_STRING "06"	/* Cannot get bustate -something is seriously wrong */

#define STATE_UNDEFINED_STRING       "99"

typedef struct IsegItemProperty {
	char object[FULLY_QUALIFIED_OBJECT_SIZE];	//line.module.channel.item  0.0.1.VoltageSet
	char type[DATA_TYPE_SIZE];	// "R4", "UI4", "STR", "BOOL"
	char unit[UNIT_SIZE];		// "V", "A", "C", "%", "%/s", "s"
	char access[ACCESS_SIZE];	// "R", "W", "RW"
	char quality[QUALITY_SIZE];
} IsegItemProperty;
#define EmptyIsegItemProperty { "", "", "", "", "" }


unsigned int iseg_getVersion(void);
const char *iseg_getVersionString(void);
int iseg_connect(const char *interface);
int iseg_disconnect(void);
char *iseg_getConnectedInterface(void);
int iseg_setItemValue(const IsegItemValue *item);
IsegItemValue iseg_getItemValue(const char *object);
IsegItemProperty iseg_getItemProperty(const char *object);

#ifdef __cplusplus
	}
#endif

#endif // ISEGAPI_H
