#ifndef KEDCP_CAN_DATAID_H
#define KEDCP_CAN_DATAID_H

//==================================================================

#define DCP_DATAID               0x8000
#define EDCP_DATAID_CHANNEL_CODE 0x4000
#define EDCP_DATAID_GROUP_CODE   0x2000
#define EDCP_DATAID_MODULE_CODE  0x1000
#define EDCP_DATAID_CODE         0x0fff

//==================================================================
// Enhanced Device Control Protocol	EDCP
#define	EDCP_DATAID_CHN_STATUS					0x4000
#define	EDCP_DATAID_CHN_CONTROL					0x4001
#define	EDCP_DATAID_CHN_EVENT_STATUS			0x4002
#define	EDCP_DATAID_CHN_EVENT_MASK				0x4003
#define EDCP_DATAID_CHN_MUX_SET					0x4004
#define EDCP_DATAID_CHN_DELAYED_TRIP_TIME		0x4005
#define EDCP_DATAID_CHN_DELAYED_TRIP_ACTION		0x4006
#define EDCP_DATAID_CHN_EXTERNAL_INHIBIT_ACTION	0x4007

#define	EDCP_DATAID_CHN_VOLTAGE_SET				0x4100
#define	EDCP_DATAID_CHN_CURRENT_SET				0x4101
#define	EDCP_DATAID_CHN_VOLTAGE_MEASURE 		0x4102
#define	EDCP_DATAID_CHN_CURRENT_MEASURE			0x4103
#define	EDCP_DATAID_CHN_CURRENT_TRIP			0x4101
#define	EDCP_DATAID_CHN_VOLTAGE_BOUNDS			0x4104
#define	EDCP_DATAID_CHN_CURRENT_BOUNDS			0x4105
#define	EDCP_DATAID_CHN_VOLTAGE_NOMINAL			0x4106
#define	EDCP_DATAID_CHN_CURRENT_NOMINAL			0x4107
#define	EDCP_DATAID_CHN_CURRENT_MEASURE_RANGE	0x4109
#define	EDCP_DATAID_CHN_VOLTAGE_NPOL_NOMINAL	0x4110
#define	EDCP_DATAID_CHN_CURRENT_NPOL_NOMINAL	0x4111
#define EDCP_DATAID_CHN_REGULATION_V_PARAM_P	0x4112					//Parameter PID-V-Regeler
#define EDCP_DATAID_CHN_REGULATION_V_PARAM_I	0x4113
#define EDCP_DATAID_CHN_REGULATION_V_PARAM_D	0x4114
#define EDCP_DATAID_CHN_REGULATION_I_PARAM_P	0x4115					//Parameter PID-I-Regeler
#define EDCP_DATAID_CHN_REGULATION_I_PARAM_I	0x4116
#define EDCP_DATAID_CHN_REGULATION_I_PARAM_D	0x4117
#define EDCP_DATAID_CHN_REGULATION_I_MINIMUM	0x4118
#define EDCP_DATAID_CHN_REGULATION_I_MAXIMUM	0x4119

#define	EDCP_DATAID_CHN_HIDDEN_VSET_DACWORD		0x4180					//nicht dokumentierter Befehl
#define	EDCP_DATAID_CHN_HIDDEN_ISET_DACWORD		0x4181					//nicht dokumentierter Befehl
//------------------------------------------------------------------
#define	EDCP_DATAID_CHN_GROUP_NUMBER			0x4200
//==================================================================
#define	EDCP_DATAID_MBR_STATUS					0x6000
#define	EDCP_DATAID_MBR_CONTROL					0x6001
#define	EDCP_DATAID_MBR_EVENT_STATUS			0x6002
#define	EDCP_DATAID_MBR_EVENT_MASK				0x6003
#define EDCP_DATAID_MBR_MUX_SET					0x6004
#define EDCP_DATAID_MBR_DELAYED_TRIP_TIME		0x6005
#define	EDCP_DATAID_MBR_DELAYED_TRIP_ACTION		0x6006
#define EDCP_DATAID_MBR_EXTERNAL_INHIBIT_ACTION	0x6007


#define	EDCP_DATAID_MBR_VOLTAGE_SET				0x6100
#define	EDCP_DATAID_MBR_CURRENT_SET				0x6101
#define	EDCP_DATAID_MBR_VOLTAGE_MEASURE			0x6102
#define	EDCP_DATAID_MBR_CURRENT_MEASURE			0x6103
#define	EDCP_DATAID_MBR_VOLTAGE_BOUNDS			0x6104
#define	EDCP_DATAID_MBR_CURRENT_BOUNDS			0x6105
#define	EDCP_DATAID_MBR_VOLTAGE_NOMINAL			0x6106
#define	EDCP_DATAID_MBR_CURRENT_NOMINAL			0x6107
#define	EDCP_DATAID_MBR_CURRENT_MEASURE_RANGE	0x6109
#define	EDCP_DATAID_MBR_VOLTAGE_NPOL_NOMINAL	0x6110
#define	EDCP_DATAID_MBR_CURRENT_NPOL_NOMINAL	0x6111
//------------------------------------------------------------------
#define	EDCP_DATAID_MBR_CHANNEL_GROUP_NUMBER	0x6200
//==================================================================
#define	EDCP_DATAID_MOD_STATUS					0x1000
#define	EDCP_DATAID_MOD_CONTROL					0x1001
#define	EDCP_DATAID_MOD_EVENT_STATUS			0x1002
#define	EDCP_DATAID_MOD_EVENT_MASK				0x1003
#define	EDCP_DATAID_MOD_EVENT_CHANNEL_STATUS	0x1004
#define	EDCP_DATAID_MOD_EVENT_CHANNEL_MASK		0x1005
#define	EDCP_DATAID_MOD_EVENT_GROUP_STATUS		0x1006
#define	EDCP_DATAID_MOD_EVENT_GROUP_MASK		0x1007

#define	EDCP_DATAID_MOD_STATUS2					0x1010
#define	EDCP_DATAID_MOD_CONTROL2				0x1011
#define	EDCP_DATAID_MOD_EVENT_STATUS2			0x1012
#define	EDCP_DATAID_MOD_EVENT_MASK2				0x1013

#define	EDCP_DATAID_MOD_CONTROL3				0x1014

#define	EDCP_DATAID_MOD_STATUS32				0x1080
#define	EDCP_DATAID_MOD_CONTROL32				0x1081
#define	EDCP_DATAID_MOD_EVENT_STATUS32			0x1082
#define	EDCP_DATAID_MOD_EVENT_MASK32			0x1083
#define	EDCP_DATAID_MOD_EVENT_CHANNEL_STATUS32	0x1084
#define	EDCP_DATAID_MOD_EVENT_CHANNEL_MASK32	0x1085
#define	EDCP_DATAID_MOD_EVENT_GROUP_STATUS32	0x1086
#define	EDCP_DATAID_MOD_EVENT_GROUP_MASK32		0x1087

#define EDCP_DATAID_MOD_COUNTER_SET_VALUES_CHANGED			0x1090
//------------------------------------------------------------------
#define	EDCP_DATAID_MOD_VOLTAGE_RAMP_SPEED		0x1100
#define	EDCP_DATAID_MOD_CURRENT_RAMP_SPEED		0x1101
#define	EDCP_DATAID_MOD_VOLTAGE_LIMIT_REL		0x1102
#define	EDCP_DATAID_MOD_CURRENT_LIMIT_REL		0x1103
#define	EDCP_DATAID_MOD_SUPPLY24				0x1104
#define	EDCP_DATAID_MOD_SUPPLY5					0x1105
#define	EDCP_DATAID_MOD_TEMPERATURE				0x1106
#define	EDCP_DATAID_MOD_THRESHOLD_TO_ARM_ERROR_DETECTION	0x1107
#define	EDCP_DATAID_MOD_SUPPLY230				0x1108
#define	EDCP_DATAID_MOD_TEMPERATURE2			0x1109
#define	EDCP_DATAID_MOD_TEMPERATURE3			0x110A
#define	EDCP_DATAID_MOD_SUPPLY_N24				0x110B
#define	EDCP_DATAID_MOD_SUPPLY_P12				0x110C
#define	EDCP_DATAID_MOD_SUPPLY_N12				0x110D
#define	EDCP_DATAID_MOD_SUPPLY_N5				0x110E
#define EDCP_DATAID_MOD_VMEAS_CONVERTER			0x110F
#define EDCP_DATAID_MOD_IMEAS_TOTAL				0x1110
#define EDCP_DATAID_MOD_CONVERTER_VOLTAGE_DEMANDED		0x1111
#define EDCP_DATAID_MOD_CONVERTER_FREQUENCY		0x1112
#define EDCP_DATAID_MOD_UPTIME					0x1113
#define EDCP_DATAID_MOD_FILAMENT_CONTROL		0x1114

//------------------------------------------------------------------
#define	EDCP_DATAID_MOD_SERIAL_NUMBER			0x1200
#define	EDCP_DATAID_MOD_FIRMWARE_RELEASE		0x1201
#define	EDCP_DATAID_MOD_BIT_RATE				0x1202
#define	EDCP_DATAID_MOD_FIRMWARE_NAME			0x1203
#define	EDCP_DATAID_MOD_ADC_SAMPLES_PER_SECOND	0x1204
#define	EDCP_DATAID_MOD_DIGITAL_FILTER			0x1205
#define	EDCP_DATAID_MOD_CHANNEL_NUMBER			0x1208
#define	EDCP_DATAID_MOD_ARTICLE_DESCRIPTION		0x1209
#define EDCP_DATAID_MOD_BOARD_INDEX				0x120a

//------------------------------------------------------------------
// Internal CAN commands for H101C1
#define	EDCP_DATAID_MOD_ARC_CONTROL_COUNT		0x1220
#define	EDCP_DATAID_MOD_ARC_TIME				0x1221
#define	EDCP_DATAID_MOD_ARC_WAIT				0x1222
#define	EDCP_DATAID_MOD_ARC_RAMP_SPEED			0x1223

#define	EDCP_DATAID_MOD_ARC_COUNT_MIN			0x1224
#define	EDCP_DATAID_MOD_ARC_COUNT_MAX			0x1225
#define	EDCP_DATAID_MOD_ARC_TIME_MIN			0x1226
#define	EDCP_DATAID_MOD_ARC_TIME_MAX			0x1227
#define	EDCP_DATAID_MOD_ARC_WAIT_MIN			0x1228
#define	EDCP_DATAID_MOD_ARC_WAIT_MAX			0x1229
#define	EDCP_DATAID_MOD_ARC_RAMP_MIN			0x122A
#define	EDCP_DATAID_MOD_ARC_RAMP_MAX			0x122B

#define	EDCP_DATAID_MOD_DEVICE_CONFIG			0x122C
#define	EDCP_DATAID_MOD_DEVICE_STATUS			0x122D

#define EDCP_DATAID_MOD_VOLTAGE_RAMP_MIN		0x122E
#define EDCP_DATAID_MOD_VOLTAGE_RAMP_MAX		0x122F

#define	EDCP_DATAID_MOD_FACTORY_TEST_INDEX		0x1230

#define	EDCP_DATAID_MOD_CONFIGURE_HIGH_VOLTAGE_OK	0x1240

#define	EDCP_DATAID_MOD_OPTION					0x1280
#define	EDCP_DATAID_MOD_OPTION_SPEC				0x1290
//------------------------------------------------------------------
#define	EDCP_DATAID_MOD_CONFIGURE_COMM			0x12A0
#define EDCP_DATAID_MOD_CONFIGURE_SAVE_SET_VALUES	0x12A1
#define EDCP_DATAID_SPECIAL_CONTROL_STATUS		0x12B0
#define EDCP_DATAID_SPECIAL_CONTROL_COMMAND		0x12B1

#define EDCP_DATAID_SPECIAL_CALIBRATION			0x12E0
#define EDCP_DATAID_FACTORY_RESET				0x12F0
//------------------------------------------------------------------
#define EDCP_DATAID_MOD_SET_EVMINPWM			0x1300		//Service fuer Module E16D0
#define EDCP_DATAID_MOD_SERVICE_REINITADC		0x1301		//Service EReInitADC lesen
#define EDCP_DATAID_MOD_SERVICE_DISABLE_PWM_FREQUENCY_SYNCHRONISATION	0x1302
#define	EDCP_DATAID_MOD_TEMPERATUR_SENSOR		0x1303
#define	EDCP_DATAID_MOD_CORRECTION_FACTOR_IMEAS	0x1304

#define EDCP_DATAID_MOD_SUPPLY_CHANNEL_INDEX	0x1305
#define EDCP_DATAID_MOD_SUPPLY_VOLTAGE			0x1306
//------------------------------------------------------------------
//EDCP calibration Data_ID's for a message to all channels of module - Single Instructions
#define	EDCP_DATAID_MOD_FACTORY_SAVE_CALIBDATA	0x1400    // reserved for service programs of iseg Spezialelektronik GmbH
#define	EDCP_DATAID_MOD_FACTORY_CALIB_SETTINGS	0x1401
#define	EDCP_DATAID_MOD_FACTORY_TEST_BYTE		0x1402
#define	EDCP_DATAID_MOD_FACTORY_TEST_WORD		0x1403
#define	EDCP_DATAID_MOD_FACTORY_TEST_FLOAT		0x1404
#define	EDCP_DATAID_MOD_FACTORY_TEST_ADDR		0x1405
#define	EDCP_DATAID_MOD_FACTORY_SWITCH_CURRENT_RANGE		0x1406
#define EDCP_DATAID_MOD_FACTORY_TEST_CNT_USER_NVSET_NVMEAS	0x1408
#define EDCP_DATAID_MOD_FACTORY_TEST_CNT_USER_NISET_NIMEAS	0x1409
#define EDCP_DATAID_MOD_FACTORY_TEST_SET_USER_VNOMINAL	0x1410
#define EDCP_DATAID_MOD_FACTORY_TEST_SET_USER_INOMINAL	0x1411
#define EDCP_DATAID_MOD_FACTORY_CALIB_ADDRESS_OFFSET_FROM_INDEX	0x1412

#define EDCP_DATAID_SPECIAL_STATUS				0x1480
#define EDCP_DATAID_SPECIAL_COMMAND				0x1481
#define EDCP_DATAID_SPECIAL_ADDRESS				0x1482
#define EDCP_DATAID_SPECIAL_RDATA				0x1483
#define EDCP_DATAID_SPECIAL_WDATA				0x1484
//------------------------------------------------------------------
#define	EDCP_DATAID_MOD_FACTORY_FLASH			0x1500
//==========================================================================
#define EDCP_DATAID_MOD_FACTORY_GLOBAL_DATA		0x1600	// belegt bis 0x16FF

//==================================================================
#define	EDCP_DATAID_CRATE_STATUS				0x1A00
#define	EDCP_DATAID_CRATE_CONTROL				0x1A01
#define	EDCP_DATAID_CRATE_EVENT_STATUS			0x1A02
#define	EDCP_DATAID_CRATE_EVENT_MASK			0x1A03
#define	EDCP_DATAID_CRATE_FAN_SPEED				0x1A04
#define	EDCP_DATAID_CRATE_ON_OFF				0x1A05
#define	EDCP_DATAID_CRATE_CHASSIS_SERIAL_NUMBER	0x1A06
#define	EDCP_DATAID_CRATE_BACKPLANE_TYPE		0x1A07

//===========================================================================
#define	EDCP_DATAID_GRP_FLEXIBLE				0x2000
#define	EDCP_DATAID_GRP_TEMPERATURE_SENSOR		0x2001
#define	EDCP_DATAID_GRP_SUPPLY_MEASURE			0x2002
#define	EDCP_DATAID_GRP_SUPPLY_NOMINAL			0x2003
#define EDCP_DATAID_GRP_FACTORY_VALUE_CRC16_CHECK	0x2004

#define	EDCP_DATAID_GRP_CAN_BUS_RECEIVED		0x2040
#define	EDCP_DATAID_GRP_CAN_BUS_RX_OVERRUN		0x2041
#define	EDCP_DATAID_GRP_CAN_BUS_TRANSMITTED		0x2042
#define	EDCP_DATAID_GRP_CAN_BUS_TX_FULL			0x2043
#define	EDCP_DATAID_GRP_CAN_BUS_DROPPED			0x2044
#define	EDCP_DATAID_GRP_CAN_BUS_ERROR			0x2045
#define	EDCP_DATAID_GRP_CAN_BUS_THROTTLE		0x2046
#define	EDCP_DATAID_GRP_CAN_BUS_STATUS			0x2047
#define	EDCP_DATAID_GRP_CAN_BUS_DISABLED		0x2048
#define	EDCP_DATAID_GRP_CAN_BUS_BIT_RATE		0x2049

#define	EDCP_DATAID_GRP_VOLTAGE_SET				0x2100
#define	EDCP_DATAID_GRP_CURRENT_SET				0x2101
//==================================================================
#define	EDCP_DATAID_GRP_ON_OFF_ALL_CHANNELS					0x2200
#define	EDCP_DATAID_GRP_EMCY_ALL_CHANNELS					0x2201
#define	EDCP_DATAID_GRP_EVNT_STAT_VLIMIT_ALL_CHANNELS		0x2202
#define	EDCP_DATAID_GRP_EVNT_STAT_ILIMIT_ALL_CHANNELS		0x2203
#define	EDCP_DATAID_GRP_EVNT_STAT_TRIP_ALL_CHANNELS			0x2204
#define	EDCP_DATAID_GRP_EVNT_STAT_INHIBIT_ALL_CHANNELS		0x2205
#define EDCP_DATAID_GRP_SET_ALL_ST_PORTS					0x2210
#define EDCP_DATAID_GRP_SET_ALL_ST_DIR						0x2211
#define EDCP_DATAID_GRP_SET_ALL_ON_PORTS					0x2212
#define EDCP_DATAID_GRP_SET_ALL_ON_DIR						0x2213
#define EDCP_DATAID_GRP_EEPROM_ADDR							0x2214
#define EDCP_DATAID_GRP_SET_ALL_DB_DIR_PORTS				0x2215


#define	EDCP_DATAID_GRP_ON_OFF_ALL_CHANNELS_EXTENDER		0x2280	//von 0x2280 - 0x228f
#define	EDCP_DATAID_GRP_EMCY_ALL_CHANNELS_EXTENDER			0x2290	//von 0x2290 - 0x229f
//==================================================================
// Device Control Protocol DCP
#define	DCP_DATAID_CHN_VOLTAGE_MEASURE			0x80
#define	DCP_DATAID_CHN_CURRENT_MEASURE			0x90
#define	DCP_DATAID_CHN_VOLTAGE_SET				0xa0
#define	DCP_DATAID_CHN_STATUS					0xb0
#define	DCP_EXTDATAID_CHN_CURRENT_TRIP			0x8080
#define	DCP_EXTDATAID_CHN_NOMINALS				0x8090
#define	DCP_EXTDATAID_CHN_CURRENT_SET			0x80a0
#define DCP_DATAID_NHS_CHN_GO					0x88
#define	DCP_DATAID_NHS_CHN_LIMIT				0x98
#define	DCP_DATAID_NHS_CHN_ITRIP				0xa8
#define	DCP_DATAID_NHS_CHN_GRAD					0xb0
#define DCP_DATAID_NHS_EXT_GRAD					0xb4
#define	DCP_DATAID_NHS_CHN_ASTART				0xb8
//==================================================================
//Data_ID's for a message to all channels of module - Single Instructions
#define	DCP_DATAID_MOD_GENERAL_STATUS			0xc0    // general status
#define		b_EEPisWr		b7

#define	DCP_DATAID_MOD_STATUS_VOLTAGE_LIMIT		0xc4    // status of voltage limit of all channels (bool array)
#define	DCP_DATAID_MOD_STATUS_CURRENT_LIMIT		0xc8    // status of hardware current limit of all channels (bool array)
#define	DCP_DATAID_MOD_ON_OFF					0xcc    // switch on or off via bool array for all channels
#define	DCP_DATAID_MOD_RAMP_SPEED				0xd0    // ramp speed if the set voltage will changed of the channel will switched off
#define	DCP_DATAID_MOD_EMERGENCY_OFF			0xd4    // emergency off without ramp  via bool array for all channels
#define	DCP_DATAID_MOD_LOG_ON					0xd8    // log on which send after power on from the device
#define	DCP_DATAID_MOD_BIT_RATE					0xdc    // please refer manual before write any bit rate
#define	DCP_DATAID_MOD_DEVICEID_SOFTWAREID		0xe0    // serial number, software release and number of channel of the device
#define	DCP_DATAID_MOD_VOLTAGE_GROUPSET			0xe4    // set voltage for all channels
#define	DCP_DATAID_MOD_HW_CURRENT_LIMIT			0xe8    // hardware current limit
#define	DCP_DATAID_MOD_KILL						0xec    // set of kill enable/disable via bool array of all channels
#define	DCP_DATAID_MOD_FILTER					0xf0    // value to change the convertion time (see manual)
#define	DCP_DATAID_MOD_NOMINAL_VALUES			0xf4	  // maximun of nominal valuses over all channels
#define	DCP_DATAID_MOD_STATUS_CURRENT_TRIP		0xf8    // software current trip
//#define DCP_DATAID_MOD_FACTORY_SETTINGS		0xfc    // reserved for service programs of iseg Spezialelektronik GmbH

#define	DCP_DATAID_MOD_NHS_STATUS				0xc4

//#define MOD_EXT_DATA_ID_CONTROL		0xc0
/*
#define		b_EEPWr		b7
#define		b_KilEna	b6
#define		b_Supply	b5
#define		b_Adjust	b4
#define		b_SLoop		b2

#define		b_Clear		b6
*/
#define	DCP_EXTDATAID_MOD_SUPPLY					0x80c0
#define	DCP_EXTDATAID_MOD_SUPPLY_FLOAT				0x80c4
#define	DCP_EXTDATAID_MOD_CHALLOCATION				0x80c8
#define	DCP_EXTDATAID_MOD_CHAVAILABILITY			0x80cc
#define	DCP_EXTDATAID_MOD_STATUS_EXT_INHIBIT		0x80d0
#define	DCP_EXTDATAID_MOD_RELAY_MASK				0x80d4
#define	DCP_EXTDATAID_MOD_THRESHOLD_ERROR_STATUS	0x80d8
#define	DCP_EXTDATAID_MOD_PWM_CALIBRATION			0x80dc
#define	DCP_EXTDATAID_MOD_REGULATION_ERROR			0x80e0
#define	DCP_EXTDATAID_MOD_CURRENT_GROUPSET			0x80e4
#define	DCP_EXTDATAID_MOD_HW_VOLTAGE_LIMIT			0x80e8

#define	MOD

#define ChnCalDataCnt 14

#define EDCP_MAX_STRING_LENGTH 7
#define EDCP_GROUP_MAX_STRING_LENGTH 64
#define EDCP_SINGLE_GROUP_FRAME_LENGTH 5

#endif // KEDCP_CAN_DATAID_H
